#include <iostream>
#include <string.h>

class Fstring
{
protected:
	char* p;
public:
	//Fstring();
	Fstring(char* inp);
	friend std::ostream& operator<<(std::ostream&,const Fstring&);
	//~Fstring();
	//Fstring(const Fstring&);
	//Fstring& operator=(const Fstring&);
};

/*Fstring::Fstring()
{
	p = new char[1];
	p[0]='\0';
	std::cout << "construction de base adresse " << (int)p << std::endl;
}*/

Fstring::Fstring(char* inp)
{
	p = new char[strlen(inp)+1];
	strcpy(p,inp);
	std::cout << "construction adresse " << (int)p << std::endl;
}

std::ostream& operator<<(std::ostream& os,const Fstring& s)
{
	os << s.p;
	return os;
}

/*Fstring::~Fstring()
{
	std::cout << "destruction adresse " << (int)p << std::endl;
	delete [] p;
}*/

/*Fstring::Fstring(const Fstring& in)
{
	p = new char[strlen(in.p)+1];
	strcpy(p,in.p);
	std::cout << "construction par recopie adresse " << (int)p << std::endl;
}

Fstring& Fstring::operator=(const Fstring& in)
{
	std::cout << "Assign egal "<< std::endl;	
	if (&in!=this)
	{
		std::cout << "destruction dans egal adresse " << (int)p << std::endl;		
		delete [] p;
		p = new char[strlen(in.p)+1];
		strcpy(p,in.p);
		std::cout << "construction dans egal adresse " << (int)p << std::endl;
	}
	return *this;
}
*/

int main()
{
	Fstring f("plouf");
	std::cout << f << std::endl;
	Fstring g(f);
	//Fstring h;
	//h = g;
	std::cout << f << std::endl;
	std::cout << g << std::endl;
	//std::cout << h << std::endl;
	//g = g;
	std::cout << "programme fini" << std::endl;
	return 0;
}


/*!F

  Un tuto pour bien normaliser les classes. On parle de normalisation de Coplien.

  Exemple : une classe Fstring, qui contient un pointeur vers une chaine.
  

  On a :

  Un constructeur a partir d'un char*
  un operateur << pour afficher la chaine.

  Lancez le programme.
  un f est cr : le constructeur est appel : un new est fait.

  puis on construit un deuxieme Fstring avec :

  Fstring g(f);  --> a recopie

  Comme vous n'avez pas encore dit comment recopier, a recopie octet par octet, donc a recopie le pointeur, et non la zone alloue
  uniquement la valeur du pointeur.

  Voila, puis on sort du programme.

  --> Un new qui n'a pas t delet : fuite mmoire, pas bon.

DESTRUCTEUR
***********

  Activez la ligne dans la classe
  //~Fstring();

  Et activez l'implmentation de cela plus bas.

  Un destructeur est unique, il ne prend pas de parametres, a le nom de la classe prcd de ~
  Dans le destructeur, on delete p. Normal.

  Le destructeur sera appel automatiquement a la fin de la vie du Fstring. Ici, on a dclar des Fstring dans le main
  Donc les destructeurs seront appels tout seul a la fin du main...

  Relancez le programme.
  a plante ? --> Non ? Vous avez de la "chance"
  Oui ? --> Normal.

  Regardez simplement, vous avez construit p une fois, et vous essayez de le dtruire 2 fois. La premiere fois, a passe,
  la deuxieme fois, c'est moins sur...

  Tout a a cause de g : il a t cr en recopiant f, et a recopi la valeur du pointeur, sans rien allouer...

CONSTRUCTEUR PAR RECOPIE
************************

  Pour remdier  cela, activez la ligne :

  //Fstring(const Fstring&);
  ainsi que son implmentation plus bas.

  Cette fois, on dit explicitement comment on construit un Fstring a partir d'un autre.
  On refait un new et on recopie.

  Lancez le programme : cette fois, 2 allocations, 2 dsallocations. Parfait !!

  Pourquoi passer par rfrence le Fstring ?
  --> Parce que sinon, vous le passez par copie. Et si vous le passez par copie, a appelle le constructeur par recopie...
  Donc a rappelle exactement la meme chose, qui lui meme va rappeler, etc etc.... a boucle infiniment, et vous finissez par
  vous prendre un stack overflow (trop d'empilage d'appel de fonctions...)

CONSTRUCTEUR VIDE
*****************

  Nous dcidons de crer un objet vide :

  activez : 
  //Fstring h;

  Lancez : il rale car il manque un constructeur par dfaut.
  Qu'a cela ne tienne, activez l'implmentation du constructeur par dfaut Fstring()

ASSIGNATION DU =
****************

  Activez la ligne :

  //h = g;

  Vous avez envie de recopier g dans h, mais savez vous faire = ?
  Si vous ne savez pas faire, par dfaut, le compilo va recopier betement les valeurs, et donc, vous allez tomber dans le meme piege :
  2 new et 3 delete --> risque de plantage.

  Activez //Fstring& operator=(const Fstring&);
  et son implmentation.
  

  Dans le if, on voit le meme code que le constructeur par recopie, prcd d'un delete :
  en effet, on dtruit l'objet dja existant (ici h) avant de lui recopier g.

  Mais pourquoi le if ?

  Je rpondrai par une question :
  Que se passe t il si vous faites g = g ?

  avec le delete, vous dtruisez g. Puis ensuite, vous essayez de copier le contenu de g dedans...
  ayayaye.... risque de plantage.

  La ligne 
  if (&in!=this)
  vous vrifiez si l'adresse de l'objet a copier n'est pas lui meme (this)
  en gros, vous dtectez que vous n'avez pas la meme chose  a gauche et a droite...


CLASSE NORMALISEE
*****************

  A partir de la, votre classe est normalise, et blinde, vous pouvez la manipuler comme un int, meme s'il y a des pointeurs dessous
  (si vous avez bien rempli les mthodes membres, tout est bon)

  Rcapitulons :
  Si on veut une classe normalise, il FAUT :

  - un constructeur vide
  - un destructeur
  - un constructeur par recopie
  - une surcharge de =.



PIEGES ET RALENTISSEMENTS
*************************

  Attention aux recopies abusives : si vous abusez, ou ne faites pas attention, vous allez recopier a tout va, et a va ralentir :

  void fonction(Fstring s)  // appel ici du constructeur par recopie de Fstring.
  {


  }

  int main()
  {
	Fstring a;
	fonction(a);


  }


  Si vous regardez les lignes ci dessus : vous passez un Fstring dans "fonction"
  Par dfaut, c'est une copie que vous passez....
  

  Si vous faites a souvent et/ou que Fstring est longue a recopier, vous effondrez les performances.
  Des fois, c'est utile de recopier, des fois, c'est inutile, pensez bien a cela...

  Ici, il aurait fallu mettre :

  void fonction(Fstring& s)

  voir 

  void fonction(const Fstring s)

  si vous voulez vous assurer que s ne sera pas modifie.... (voir tuto sur const plus loin)

!*/

/*!E
	No explanations yet.
!*/

/*
titre: Normaliser une classe.
titreE: Normalize a class.
meta: C++
metaE: C++
desc : Forme de Coplien.
descE : Coplien form.
cle  : classe de Coplien
*/

